<id>
Fix Remove Posts SP 1.3.1
</id>

<version>
1.0
</version>

<mod info>

This mod will reduce members number of posts when threads, boards or categories are removed.
It also adds a link in members Profile-Additional Information for admin to recount members posts.

Instructions:
Apply mod.
Upload:

english.lng
Sources/ManageBoards.pl
Sources/ManageCats.pl
Sources/Profile.pl
Sources/RemoveOldThreads.pl
Sources/RemoveThread.pl
Sources/SubList.pl
Sources/Subs.pl

in ASCII mode

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>


<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>

$posttxt{'01'} = "- Recount this members posts";

</add before>


<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			($id, $dummy) = split(/\|/, $curmessage);
</search for>

<add after>
			&ReducePosts($id);
</add after>


<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
					($id, $dummy) = split(/\|/, $curmessage);
</search for>

<add after>
					&ReducePosts($id);
</add after>


<edit file>
Sources/Profile.pl
</edit file>

<search for>
    </select> $txt{'461'}. <input type="submit" value="$txt{'462'}">
    </font></form></td>
</search for>

<replace>
    </select> $txt{'461'}. <input type="submit" value="$txt{'462'}">
    </form>
    ~;
    if($settings[7] eq 'Administrator') {
	$yymain .= qq~<br><a href="$cgi;action=recountposts;username=$INFO{'username'}">$posttxt{'01'}</a>~;
    }
    $yymain .= qq~
    </font></td>
</replace>


<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.txt");
</search for>

<add before>
	&ReducePosts($thread);
</add before>


<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					$yymain .= "$num = $result $txt{'122'} ($txt{'123'})<br>";
</search for>

<add after>
					&ReducePosts($num);
</add after>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
'recent',"Recent.pl&RecentPosts",
</search for>

<add after>
'recountposts',"Subs.pl&RecountPosts",
</add after>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub BoardCountSet {
</search for>

<add before>
sub ReducePosts {
	fopen(FILE, "$datadir/$_[0].txt");
	@rmessages = <FILE>;
	fclose(FILE);

	for ($i=0;$i<@rmessages;$i++) {
		chomp $rmessages[$i];
		my($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns);
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$rmessages[$i]);

		if(-e ("$memberdir/$musername.dat")) {
			fopen(FILE, "$memberdir/$musername.dat");
			@memset = <FILE>;
			fclose(FILE);
			chomp $memset[6];
			$memset[6]--;
			fopen(FILE, ">$memberdir/$musername.dat");
			foreach $rmemset (@memset) {
				chomp $rmemset;
				print FILE qq~$rmemset\n~;
			}
			fclose(FILE);
		}
	}
}

sub RecountPosts {
&is_admin;

if ($yyCatsLoaded ne 1) {
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
}

$mempostcount = 0;

foreach $curcat (@categories) {
	chomp $curcat;
	fopen(FILE, "$boardsdir/$curcat.cat");
	@catboards = <FILE>;
	fclose(FILE);
	foreach $curboard (@catboards) {
		chomp $curboard;
		fopen(FILE, "$boardsdir/$curboard.txt");
		@threads = <FILE>;
		fclose(FILE);
		for ($i = 0; $i < @threads; $i++) {
			chomp $threads[$i];
			($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
			fopen(FILE, "$datadir/$tnum.txt") || next;
			@messages = <FILE>;
			fclose(FILE);
			for ($c = 0; $c < @messages; $c++) {
				chomp $messages[$c];
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$messages[$c]);
				if($INFO{'username'} eq $musername) {
					$mempostcount++;
				}
			}
		}
	}
}

fopen(FILE, "$memberdir/$INFO{'username'}.dat");
@memsettings=<FILE>;
fclose(FILE);
$memsettings[6] =~ s/[\n\r]//g;
$memsettings[6] = $mempostcount;
fopen(FILE, ">$memberdir/$INFO{'username'}.dat") || &fatal_error("213 $txt{'106'}: $txt{'23'} $INFO{'username'}.dat");
foreach (@memsettings) {
	chomp $_;
	print FILE qq~$_\n~;
}
fclose(FILE);

$yySetLocation = qq~$cgi;action=viewprofile;username=$INFO{'username'}~;
&redirectexit;
}

</add before>
